@THE AUTHOR REFERS TO THIS PROGRAM AS TVPFOM9.995@

@This is the first of two GAUSS programs used in the Dueker/Fischer Review@
@article in the Jan/Feb '96 issue.  This program must be ran before@
@JF96PGM2.MD since that program uses output from this one (JF96DAT2.MD).@
@JF96DAT2.MD is pieced together using VELFO9T.995 and VELFTO9D.995 (both@
@are output from this program).@



@>>>Time varying parameter model  >>>>>>>>>>>@
@>>>>>>>>>>>>>>>>>>>>with Markov  Varance  >>>>>>>>>>>>>>>>>>>@
@>>>>>>>>>>>>>>>>>>>>Using Optmum Proc  >>>>>>>>>>>>>>>>>>>>>>@

                  @===========> GAUSS 2.1 + NEW APPLICATION MODULE@
new;
#lineson;
library optmum;
#include optmum.ext;
optset;

output file=c:\review\mjd_jf96\programs\velfo9t.995 reset;

load dat[107,9]=c:\review\mjd_jf96\data\fomc995.txt;
@ date cpi res base m1 m2 ff tb3 tbond10 @
t=107;
ff= 100*ln((1+dat[6:t-3,7]/100)./(1+dat[5:t-4,7]/100))
   +25*ln(dat[9:t,2]./dat[5:t-4,2])
   -25*ln(dat[5:t-4,2]./dat[1:t-8,2]);
y= ff[1:rows(ff)];
inf= 10*ln((dat[5:t-4,2])./(dat[1:t-8,2]));
ff2= 10*ln((1+dat[5:t-4,7]/100)./(1+dat[4:t-5,7]/100));
spr= 10*ln((dat[5:t-4,9])./(dat[5:t-4,8]));
@ forc= ln(dat[2:t,2].*(dat[2:t,3]/100)./(1+dat[2:t,4]/100))-
      ln(dat[1:t-1,2].*(dat[1:t-1,3]/100)./(1+dat[1:t-1,4]/100));
@
@ vola= 100*(1+dat[1:t-2,8]/100)./(1+dat[1:t-2,7]/100); @
 qtr_idx= dat[6:t-3,1];
t=rows(y);

AA=.1*ones(t,1)~ff2~inf~spr;

yy=y; dddd=AA;
beta=invpd(AA'AA)*AA'yy;
res= yy-AA*beta; sig=res'res/(t-1);
beta; sig; my=yy-sumc(yy)/rows(yy);
r2= 1 - res'res/(my'my);
r2;; r2;

format /m1 /rd 12,6;
qtr_idx~y;


         START=11;    /* 1961.1--1987.4 */
         PRMTR_NO=8;
              /*  >>Number of parameters to be estimated. >> */
         TVP_NO=4;    /* >>Number of Time-varying Coefficients   >> */
/*
prmtr_in=0.323289|0.090582|0.032839|0.040333|0.063470|0.01|0.970468|
         0.928421|0.958763;

output on; "initial values of prmtr is(vre,intcpt,dint,inf,surp,mlag,w,p,q";
*/
output on;
prmtr_in=.4*sig|.2|.2|.2|.2|2.5*sig|.90|.95;
prmtr_in;

     PRIOR_CF=zeros(TVP_NO,1);  /* Initial values of reg coefs */
  PRIOR_CF=inv(dddd[1:10,.]'dddd[1:10,.])*dddd[1:10,.]'yy[1:10];

     PRIOR_VR=EYE(TVP_NO)*START;  /* Initial var-cov for reg coef */

/* Maximum Likelihood Estimation
==================================================
*/

{xout,fout,gout,hout}=optmum(&lik_fcn,tran_inv(PRMTR_IN));
       /* prmtr estimates, -log lik value, Grandient, code */

PRM_FNL=TRANS(xout);
F_SS =SAVE_OUT(PRM_FNL);
OUTPUT FILE=c:\review\mjd_jf96\programs\velfo9d.995 RESET;
F_SS;

      ?"Calculating Hessian and its inverse.....";;
      ?"THANK YOU FOR YOUR PATIENCE..............!!!";
 hout=inv(hessp(&lik_fcn,xout));

grdn_fnl=gradfd(&TRANS,xout);
Hsn_fnl=grdn_fnl*hout*grdn_fnl';
SD_fnl =sqrt(diag(Hsn_fnl));
 /* Standard errors of the estimated coefficients */


output on;
?"==FINAL OUTPUT========================================================";
?"likelihood value is ";; fout;
?"Estimated parameters are:";
prm_fnl';
?"var-cov matrix is:"; Hsn_fnl;
?"Standard errors of parameters are:"; sd_fnl;
?"===============================================================";
END;
/* ========================================================================
======================================================================== */
PROC LIK_FCN(PRMTR1);

local prmtr, ppr,qpr,aaa,prob__0,prob__1,p_cf_0,p_cf_1, p_vr_0,
      p_vr_1, qq, lik, j_iter, h, pr__0_l,pr__1_l, pst_cf0, pst_cf1,
      pst_vr0, pst_vr1, f_cast0, f_cast1, ss00, ss01, ss10, ss11,
      pr_vl00, pr_vl01, pr_vl10, pr_vl11, pr_val,k_gn00, k_gn01,
      k_gn10, k_gn11, p_cf00, p_cf01, p_cf10, p_cf11, p_vr00, p_vr01,
      p_vr10, p_vr11, pro_00, pro_01, pro_10, pro_11, likv;

EXTERNAL PROC TRANS, V_PROB;

PRMTR=TRANS(PRMTR1);
PPR=PRMTR[7,1];    @Pr[St=1/St-1=1]@
QPR=PRMTR[8,1];    @Pr[St=0/St-1=0]@

AAA=EYE(TVP_NO);

/* >>>>>>>>>>>>>>>>>>>>>>>>>  INITIAL PROB. Pr[S0/Y0] */

        PROB__1=(1-QPR)/(2-PPR-QPR);  /* Pr[St-1=1/Yt-1], STEADY STATE PROB. */
        PROB__0=1-PROB__1  ;          /* Pr[ST-1=0/Yt-1], STEADY STATE PROB  */


P_CF_0=PRIOR_CF; P_CF_1=PRIOR_CF;
P_VR_0=PRIOR_VR; P_VR_1=PRIOR_VR; /* Initial values */

QQ=(PRMTR[2,1]^2~0~0~0)|
   (0~PRMTR[3,1]^2~0~0)|
   (0~0~PRMTR[4,1]^2~0)|
   (0~0~0~PRMTR[5,1]^2);

LIKV=0.0;
J_ITER = 1;
DO UNTIL J_ITER>T;

/* H=AA[J_ITER,.]~zz[J_ITER,.]; */
H=AA[J_ITER,.];
        PR__0_L= QPR*PROB__0 + (1-PPR)*PROB__1; /* Pr[St=0/Yt-1] */
    PR__1_L= (1-QPR)*PROB__0 + PPR*PROB__1;     /* Pr[St=1/Yt-1] */


/* ===================PREDICTION============================= */
PST_CF0 = AAA * P_CF_0;              /* Prediction of coef when St-1=0 */
PST_CF1=AAA*P_CF_1;

PST_VR0 = AAA * P_VR_0 * AAA' +QQ;
PST_VR1 = AAA * P_VR_1 * AAA' +QQ;

F_CAST0 = yy[J_ITER,.] - H * PST_CF0;      /* Forecast error when St-1=0 */
F_CAST1 = yy[J_ITER,.] - H * PST_CF1;      /* Forecast error when St-1=0 */

SS00= H * PST_VR0 * H' + PRMTR[1,1]^2;       /* St-1=0,St=0 */
SS01= H*  PST_VR0 * H' + PRMTR[6,1]^2; /* St-1=0,St=1 */
SS10= H * PST_VR1 * H' + PRMTR[1,1]^2; /* St-1=1,St=0 */
SS11= H * PST_VR1 * H' + PRMTR[6,1]^2; /* St-1=1,St=1  */


/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */
PR_VL00=V_PROB(F_CAST0,SS00)*    QPR*PROB__0;     /* Pr[St,Yt/Yt-1] */
PR_VL01=V_PROB(F_CAST0,SS01)*(1-QPR)*PROB__0;
PR_VL10=V_PROB(F_CAST1,SS10)*(1-PPR)*PROB__1;
PR_VL11=V_PROB(F_CAST1,SS11)*    PPR*PROB__1;

PR_VAL=PR_VL00+PR_VL01+PR_VL10+PR_VL11;        /* Pr[Yt/Yt-1] */
/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */


LIK=-1*LN(PR_VAL);


/* =======================UPDATING===============================*/
K_GN00 =PST_VR0 * H' / SS00;
K_GN01 =PST_VR0 * H' / SS01;
K_GN10 =PST_VR1 * H' / SS10;
K_GN11 =PST_VR1 * H' / SS11;

P_CF00 = PST_CF0 + K_GN00 * F_CAST0;
P_CF01 = PST_CF0 + K_GN01 * F_CAST0;
P_CF10 = PST_CF1 + K_GN10 * F_CAST1;
P_CF11 = PST_CF1 + K_GN11 * F_CAST1;

P_VR00 = (EYE(TVP_NO) - K_GN00 * H ) * PST_VR0;
P_VR01 = (EYE(TVP_NO) - K_GN01 * H ) * PST_VR0;
P_VR10 = (EYE(TVP_NO) - K_GN10 * H ) * PST_VR1;
P_VR11 = (EYE(TVP_NO) - K_GN11 * H ) * PST_VR1;

@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
        PRO_00=PR_VL00/PR_VAL;                    @Pr[St,St-1/Yt]@
        PRO_01=PR_VL01/PR_VAL;
        PRO_10=PR_VL10/PR_VAL;
        PRO_11=PR_VL11/PR_VAL;

        PROB__0=PRO_00+PRO_10;         @Pr[St=0/Yt]@
        PROB__1=PRO_01+PRO_11;         @Pr[St=1/Yt]@
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

P_CF_0=(PRO_00*P_CF00 + PRO_10*P_CF10)/PROB__0;
P_CF_1=(PRO_01*P_CF01 + PRO_11*P_CF11)/PROB__1;

P_VR_0=(PRO_00*(P_VR00+(P_CF_0-P_CF00)*(P_CF_0-P_CF00)')+
        PRO_10*(P_VR10+(P_CF_0-P_CF10)*(P_CF_0-P_CF10)'))/PROB__0;

P_VR_1=(PRO_01*(P_VR01+(P_CF_1-P_CF01)*(P_CF_1-P_CF01)')+
        PRO_11*(P_VR11+(P_CF_1-P_CF11)*(P_CF_1-P_CF11)'))/PROB__1;


IF J_ITER < START; goto skip; endif;
LIKV = LIKV+LIK;
skip:  J_ITER = J_ITER+1;
ENDO;

RETP(LIKV);
ENDP;

PROC (1) = SAVE_OUT(PRMTR1);

local prmtr, ppr,qpr,aaa,prob__0,prob__1,p_cf_0,p_cf_1, p_vr_0,
      p_vr_1, qq, lik, j_iter, h, pr__0_l,pr__1_l, pst_cf0, pst_cf1,
      pst_vr0, pst_vr1, f_cast0, f_cast1, ss00, ss01, ss10, ss11,
      pr_vl00, pr_vl01, pr_vl10, pr_vl11, pr_val,k_gn00, k_gn01,
      k_gn10, k_gn11, p_cf00, p_cf01, p_cf10, p_cf11, p_vr00, p_vr01,
      p_vr10, p_vr11, pro_00, pro_01, pro_10, pro_11, likv,cf,vr,
      DTA_MAT, SS,S1,S2,f_cast,coeffs;

EXTERNAL PROC TRANS, V_PROB;

DTA_MAT=ZEROS(T,4);

PRMTR=PRMTR1;
PPR=PRMTR[7,1];    @Pr[St=1/St-1=1]@
QPR=PRMTR[8,1];    @Pr[St=0/St-1=0]@

AAA=EYE(TVP_NO);

@>>>>>>>>>>>>>>>>>>>>>>>>>  INITIAL PROB. Pr[S0/Y0] @

        PROB__1=(1-QPR)/(2-PPR-QPR);   @Pr[St-1=0/Yt-1], STEADY STATE PROB.@
        PROB__0=1-PROB__1  ;           @Pr[ST-1=1/Yt-1], STEADY STATE PROB @


P_CF_0=PRIOR_CF; P_CF_1=PRIOR_CF;
P_VR_0=PRIOR_VR; P_VR_1=PRIOR_VR; @ Initial values@
/*
QQ=(PRMTR[2,1]^2~0~0~0~0)|(0~PRMTR[3,1]^2~0~0~0)|(0~0~PRMTR[4,1]^2~0~0)|
   (0~0~0~PRMTR[5,1]^2~0)|(0~0~0~0~PRMTR[6,1]^2);
*/
QQ=(PRMTR[2,1]^2~0~0~0)|
   (0~PRMTR[3,1]^2~0~0)|
   (0~0~PRMTR[4,1]^2~0)|
   (0~0~0~PRMTR[5,1]^2);
/*
QQ=(PRMTR[2,1]^2~0)|
   (0~PRMTR[3,1]^2);
*/

LIKV=0.0;

J_ITER = 1;
DO UNTIL J_ITER>T;

@H=AA[J_ITER,.]~zz[J_ITER,.];@
H=AA[J_ITER,.];

        PR__0_L= QPR*PROB__0 + (1-PPR)*PROB__1;     @Pr[St=0/Yt-1]@
        PR__1_L= (1-QPR)*PROB__0 + PPR*PROB__1;     @Pr[St=1/Yt-1]@


@===================PREDICTION=============================@
PST_CF0 = AAA * P_CF_0;                   @ Prediction of coef when St-1=0 @
PST_CF1=AAA*P_CF_1;                    @Prediction of coef when St-1=1 @

          cf=prob__0*pst_cf0 +prob__1*pst_cf1;
                                      @Estimate of coefs based on past info@
cf;
@          cf=pr__0_l*pst_cf0 +pr__1_l*pst_cf1;@


PST_VR0 = AAA * P_VR_0 * AAA' +QQ;
PST_VR1 = AAA * P_VR_1 * AAA' +QQ;

          vr=  prob__0*(pst_vr0+ (cf-pst_cf0)*(cf-pst_cf0)')
         + prob__1*(pst_vr1+ (cf-pst_cf1)*(cf-pst_cf1)');

@   vr=  pr__0_l*(pst_vr0+ (cf-pst_cf0)*(cf-pst_cf0)')
         + pr__1_l*(pst_vr1+ (cf-pst_cf1)*(cf-pst_cf1)');@

@vr=> variance covariance matrix of coef(cf) calculated based on
past information only.  @

F_CAST0 = yy[J_ITER,.] - H * PST_CF0;      @ Forecast error when St-1=0 @
F_CAST1 = yy[J_ITER,.] - H * PST_CF1;      @ Forecast error when St-1=0 @


           f_cast= pr__0_l*F_CAST0+ pr__1_l*F_CAST1;

   SS = H * vr * H' + (prmtr[1,1]^2 +(prmtr[6,1]^2-prmtr[1,1]^2)* pr__1_L);

/*
DTA_MAT[j_iter,.]=f_cast~  ss ~ (h*vr*h')~
                (prmtr[1,1]^2+(prmtr[6,1]^2-prmtr[1,1]^2)*pr__1_l);
*/
DTA_MAT[j_iter,.]=f_cast~  ss ~ (h*vr*h')~
                (prmtr[1,1]^2+(prmtr[6,1]^2-prmtr[1,1]^2)*pr__1_l);

SS00= H * PST_VR0 * H' + PRMTR[1,1]^2;              @ St-1=0,St=0 @
SS01= H*  PST_VR0 * H' + PRMTR[6,1]^2; @ St-1=0,St=1 @
SS10= H * PST_VR1 * H' + PRMTR[1,1]^2;              @ St-1=1,St=0 @
SS11= H * PST_VR1 * H' + PRMTR[6,1]^2; @ St-1=1,St=1 @

@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@
PR_VL00=V_PROB(F_CAST0,SS00)*    QPR*PROB__0;         @Pr[St,Yt/Yt-1]@
PR_VL01=V_PROB(F_CAST0,SS01)*(1-QPR)*PROB__0;
PR_VL10=V_PROB(F_CAST1,SS10)*(1-PPR)*PROB__1;
PR_VL11=V_PROB(F_CAST1,SS11)*    PPR*PROB__1;

PR_VAL=PR_VL00+PR_VL01+PR_VL10+PR_VL11;           @Pr[Yt/Yt-1]@
@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

@=======================UPDATING===============================@
K_GN00 =PST_VR0 * H' / SS00;
K_GN01 =PST_VR0 * H' / SS01;
K_GN10 =PST_VR1 * H' / SS10;
K_GN11 =PST_VR1 * H' / SS11;

P_CF00 = PST_CF0 + K_GN00 * F_CAST0;
P_CF01 = PST_CF0 + K_GN01 * F_CAST0;
P_CF10 = PST_CF1 + K_GN10 * F_CAST1;
P_CF11 = PST_CF1 + K_GN11 * F_CAST1;

P_VR00 = (EYE(TVP_NO) - K_GN00 * H ) * PST_VR0;
P_VR01 = (EYE(TVP_NO) - K_GN01 * H ) * PST_VR0;
P_VR10 = (EYE(TVP_NO) - K_GN10 * H ) * PST_VR1;
P_VR11 = (EYE(TVP_NO) - K_GN11 * H ) * PST_VR1;

@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
        PRO_00=PR_VL00/PR_VAL;                    @Pr[St,St-1/Yt]@
        PRO_01=PR_VL01/PR_VAL;
        PRO_10=PR_VL10/PR_VAL;
        PRO_11=PR_VL11/PR_VAL;

        PROB__0=PRO_00+PRO_10;         @Pr[St=0/Yt]@
        PROB__1=PRO_01+PRO_11;         @Pr[St=1/Yt]@
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<@

P_CF_0=(PRO_00*P_CF00 + PRO_10*P_CF10)/PROB__0;
P_CF_1=(PRO_01*P_CF01 + PRO_11*P_CF11)/PROB__1;

P_VR_0=(PRO_00*(P_VR00+(P_CF_0-P_CF00)*(P_CF_0-P_CF00)')+
        PRO_10*(P_VR10+(P_CF_0-P_CF10)*(P_CF_0-P_CF10)'))/PROB__0;

P_VR_1=(PRO_01*(P_VR01+(P_CF_1-P_CF01)*(P_CF_1-P_CF01)')+
        PRO_11*(P_VR11+(P_CF_1-P_CF11)*(P_CF_1-P_CF11)'))/PROB__1;

skip:  J_ITER = J_ITER+1;
ENDO;


RETP(DTA_MAT~qtr_idx);
ENDP;

@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
PROC TRANS(coef0); @ constraining values of reg. coeff.@
   local coef1,m,u;
      u=0.9999999999; m=0.00000000001;
   coef1= m+coef0^2;
   coef1[7:8,.]=m+(u-m)./ (1+exp(-1*coef0[7:8,.]));
   retp(coef1);
endp;

PROC TRAN_INV(coef0);
    local coef1,m,u;
       u=0.9999999999; m=0.00000000001;
    coef1=sqrt(coef0-m);

    coef1[7:8,.]=-1*ln((u-coef0[7:8,.]) ./ (coef0[7:8,.]-m));

    retp(coef1);
endp;
@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@


@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
PROC V_PROB(EV, HE);      @ CALCULATES    Pr[Yt/St,Yt-1]@
LOCAL VAL;
VAL=(1/SQRT(2*PI*HE))*EXP(-0.5*EV*EV/HE);
RETP(VAL);
ENDP;
@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

